/**
 * Copyright (c) 2011-2013 EclipseSource Muenchen GmbH and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * EclipseSource Munich - initial API and implementation
 */
package org.eclipse.emf.ecp.view.template.model;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Control Validation Template</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getOkColorHEX <em>Ok Color HEX</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getOkImageURL <em>Ok Image URL</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getOkOverlayURL <em>Ok Overlay URL
 * </em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getInfoColorHEX <em>Info Color HEX
 * </em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getInfoImageURL <em>Info Image URL
 * </em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getInfoOverlayURL <em>Info Overlay URL
 * </em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getWarningColorHEX <em>Warning Color
 * HEX</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getWarningImageURL <em>Warning Image
 * URL</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getWarningOverlayURL <em>Warning
 * Overlay URL</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getErrorColorHEX <em>Error Color HEX
 * </em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getErrorImageURL <em>Error Image URL
 * </em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getErrorOverlayURL <em>Error Overlay
 * URL</em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getCancelColorHEX <em>Cancel Color HEX
 * </em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getCancelImageURL <em>Cancel Image URL
 * </em>}</li>
 * <li>{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getCancelOverlayURL <em>Cancel Overlay
 * URL</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate()
 * @model
 * @generated
 */
public interface VTControlValidationTemplate extends EObject
{
	/**
	 * Returns the value of the '<em><b>Ok Color HEX</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ok Color HEX</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Ok Color HEX</em>' attribute.
	 * @see #setOkColorHEX(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_OkColorHEX()
	 * @model
	 * @generated
	 */
	String getOkColorHEX();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getOkColorHEX
	 * <em>Ok Color HEX</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Ok Color HEX</em>' attribute.
	 * @see #getOkColorHEX()
	 * @generated
	 */
	void setOkColorHEX(String value);

	/**
	 * Returns the value of the '<em><b>Ok Image URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ok Image URL</em>' attribute isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Ok Image URL</em>' attribute.
	 * @see #setOkImageURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_OkImageURL()
	 * @model
	 * @generated
	 */
	String getOkImageURL();

	/**
	 * Sets the value of the '{@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getOkImageURL
	 * <em>Ok Image URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Ok Image URL</em>' attribute.
	 * @see #getOkImageURL()
	 * @generated
	 */
	void setOkImageURL(String value);

	/**
	 * Returns the value of the '<em><b>Ok Overlay URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ok Overlay URL</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Ok Overlay URL</em>' attribute.
	 * @see #setOkOverlayURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_OkOverlayURL()
	 * @model
	 * @generated
	 */
	String getOkOverlayURL();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getOkOverlayURL
	 * <em>Ok Overlay URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Ok Overlay URL</em>' attribute.
	 * @see #getOkOverlayURL()
	 * @generated
	 */
	void setOkOverlayURL(String value);

	/**
	 * Returns the value of the '<em><b>Info Color HEX</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Info Color HEX</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Info Color HEX</em>' attribute.
	 * @see #setInfoColorHEX(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_InfoColorHEX()
	 * @model
	 * @generated
	 */
	String getInfoColorHEX();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getInfoColorHEX
	 * <em>Info Color HEX</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Info Color HEX</em>' attribute.
	 * @see #getInfoColorHEX()
	 * @generated
	 */
	void setInfoColorHEX(String value);

	/**
	 * Returns the value of the '<em><b>Info Image URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Info Image URL</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Info Image URL</em>' attribute.
	 * @see #setInfoImageURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_InfoImageURL()
	 * @model
	 * @generated
	 */
	String getInfoImageURL();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getInfoImageURL
	 * <em>Info Image URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Info Image URL</em>' attribute.
	 * @see #getInfoImageURL()
	 * @generated
	 */
	void setInfoImageURL(String value);

	/**
	 * Returns the value of the '<em><b>Info Overlay URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Info Overlay URL</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Info Overlay URL</em>' attribute.
	 * @see #setInfoOverlayURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_InfoOverlayURL()
	 * @model
	 * @generated
	 */
	String getInfoOverlayURL();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getInfoOverlayURL
	 * <em>Info Overlay URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Info Overlay URL</em>' attribute.
	 * @see #getInfoOverlayURL()
	 * @generated
	 */
	void setInfoOverlayURL(String value);

	/**
	 * Returns the value of the '<em><b>Warning Color HEX</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Warning Color HEX</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Warning Color HEX</em>' attribute.
	 * @see #setWarningColorHEX(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_WarningColorHEX()
	 * @model
	 * @generated
	 */
	String getWarningColorHEX();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getWarningColorHEX
	 * <em>Warning Color HEX</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Warning Color HEX</em>' attribute.
	 * @see #getWarningColorHEX()
	 * @generated
	 */
	void setWarningColorHEX(String value);

	/**
	 * Returns the value of the '<em><b>Warning Image URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Warning Image URL</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Warning Image URL</em>' attribute.
	 * @see #setWarningImageURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_WarningImageURL()
	 * @model
	 * @generated
	 */
	String getWarningImageURL();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getWarningImageURL
	 * <em>Warning Image URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Warning Image URL</em>' attribute.
	 * @see #getWarningImageURL()
	 * @generated
	 */
	void setWarningImageURL(String value);

	/**
	 * Returns the value of the '<em><b>Warning Overlay URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Warning Overlay URL</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Warning Overlay URL</em>' attribute.
	 * @see #setWarningOverlayURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_WarningOverlayURL()
	 * @model
	 * @generated
	 */
	String getWarningOverlayURL();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getWarningOverlayURL
	 * <em>Warning Overlay URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Warning Overlay URL</em>' attribute.
	 * @see #getWarningOverlayURL()
	 * @generated
	 */
	void setWarningOverlayURL(String value);

	/**
	 * Returns the value of the '<em><b>Error Color HEX</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Error Color HEX</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Error Color HEX</em>' attribute.
	 * @see #setErrorColorHEX(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_ErrorColorHEX()
	 * @model
	 * @generated
	 */
	String getErrorColorHEX();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getErrorColorHEX
	 * <em>Error Color HEX</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Error Color HEX</em>' attribute.
	 * @see #getErrorColorHEX()
	 * @generated
	 */
	void setErrorColorHEX(String value);

	/**
	 * Returns the value of the '<em><b>Error Image URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Error Image URL</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Error Image URL</em>' attribute.
	 * @see #setErrorImageURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_ErrorImageURL()
	 * @model
	 * @generated
	 */
	String getErrorImageURL();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getErrorImageURL
	 * <em>Error Image URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Error Image URL</em>' attribute.
	 * @see #getErrorImageURL()
	 * @generated
	 */
	void setErrorImageURL(String value);

	/**
	 * Returns the value of the '<em><b>Error Overlay URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Error Overlay URL</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Error Overlay URL</em>' attribute.
	 * @see #setErrorOverlayURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_ErrorOverlayURL()
	 * @model
	 * @generated
	 */
	String getErrorOverlayURL();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getErrorOverlayURL
	 * <em>Error Overlay URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Error Overlay URL</em>' attribute.
	 * @see #getErrorOverlayURL()
	 * @generated
	 */
	void setErrorOverlayURL(String value);

	/**
	 * Returns the value of the '<em><b>Cancel Color HEX</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cancel Color HEX</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Cancel Color HEX</em>' attribute.
	 * @see #setCancelColorHEX(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_CancelColorHEX()
	 * @model
	 * @generated
	 */
	String getCancelColorHEX();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getCancelColorHEX
	 * <em>Cancel Color HEX</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Cancel Color HEX</em>' attribute.
	 * @see #getCancelColorHEX()
	 * @generated
	 */
	void setCancelColorHEX(String value);

	/**
	 * Returns the value of the '<em><b>Cancel Image URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cancel Image URL</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Cancel Image URL</em>' attribute.
	 * @see #setCancelImageURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_CancelImageURL()
	 * @model
	 * @generated
	 */
	String getCancelImageURL();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getCancelImageURL
	 * <em>Cancel Image URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Cancel Image URL</em>' attribute.
	 * @see #getCancelImageURL()
	 * @generated
	 */
	void setCancelImageURL(String value);

	/**
	 * Returns the value of the '<em><b>Cancel Overlay URL</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cancel Overlay URL</em>' attribute isn't clear, there really should be more of a
	 * description here...
	 * </p>
	 * <!-- end-user-doc -->
	 *
	 * @return the value of the '<em>Cancel Overlay URL</em>' attribute.
	 * @see #setCancelOverlayURL(String)
	 * @see org.eclipse.emf.ecp.view.template.model.VTTemplatePackage#getControlValidationTemplate_CancelOverlayURL()
	 * @model
	 * @generated
	 */
	String getCancelOverlayURL();

	/**
	 * Sets the value of the '
	 * {@link org.eclipse.emf.ecp.view.template.model.VTControlValidationTemplate#getCancelOverlayURL
	 * <em>Cancel Overlay URL</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @param value the new value of the '<em>Cancel Overlay URL</em>' attribute.
	 * @see #getCancelOverlayURL()
	 * @generated
	 */
	void setCancelOverlayURL(String value);

} // VTControlValidationTemplate
